Summary: Free and portable clone of the ARJ archiver
Name: arj+xenu
Version: 1.01
Release: 1
Copyright: GPL
Group: Applications/Archiving
Source: ftp://download.gnu.org.ua/pub/release/microutf8/%{name}-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: autoconf

%description
The arj+xenu program is a fork of free clone of the ARJ archiver for DOS and Windows.
It can be used to create and extract archives and uses the save format
as the proprietary version.

Install the arj+xenu package if you need to uncompress and create .arj format
archives.

%prep
%setup -q -n arj

%build
cd gnu
autoconf
./configure
cd ..
make prepare RPM_OPT_FLAGS="$RPM_OPT_FLAGS"
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS"

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/bin

install -m 755 linux-gnu/en/rs/arj/arj $RPM_BUILD_ROOT/usr/bin/arj
install -m 755 linux-gnu/en/rs/arjdisp/arjdisp $RPM_BUILD_ROOT/usr/bin/arjdisp
install -m 755 linux-gnu/en/rs/rearj/rearj $RPM_BUILD_ROOT/usr/bin/rearj

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc doc/*

/usr/bin/*

%changelog
* Wed Nov 02 2011 Tomasz Konojacki <xenu@poczta.onet.pl>
- Adapted for arj+xenu

* Sun Dec 15 2002 Andrew Belov <andrew_belov@newmail.ru>
- Adapted for the previous naming changes

* Sat Dec 14 2002 Pavel Roskin <proski@gnu.org>
- Initial version

